#include <iostream>
#include <string>
#include <sstream>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

const int maxn = 50;

int g[maxn][maxn];
int p[maxn];

int main(int argc, char* argv[])
{
    istringstream ss_randseed(argv[1]);
    istringstream ss_n(argv[2]);
    istringstream ss_m(argv[3]);

    int randseed;
    ss_randseed >> randseed;
    srand(randseed);

    int n;
    ss_n >> n;
    int m;
    ss_m >> m;

    assert(1 <= n && n <= 50);
    assert(0 <= m && m <= n*(n-1)/2);

    int i, j;

    for (i = 0; i < n; i++) {
        p[i] = i;
    }
    /*for (i = 0; i < 3*n; i++) {
        int u = rand() % n;
        int v = rand() % n; 
        swap(p[u], p[v]);
    }*/

    vector<pair<int, int> > edges;
    while (edges.size() < m) {
        int u = rand() % (n-1);
        int v = u+1 + rand() % (n-1-u);
        if (!g[u][v]) {
            edges.push_back(make_pair(p[u]+1, p[v]+1));
            g[u][v] = 1;
        }
    }

    sort(edges.begin(), edges.end());

    cout << n << " " << m << endl;
    for (i = 0; i < m; i++) {
        cout << edges[i].first << " " << edges[i].second << endl;
    }
}
